
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【深度】扒开V8引擎的源码，我找到了你们想要的前端算法（下次面试官再问算法，用它怼回去！） / 憋错料</title>

    <meta name="description" content="【深度】扒开V8引擎的源码，我找到了你们想要的前端算法（下次面试官再问算法，用它怼回去！） 算法对于前端工程师来说总有一层神秘色彩,这篇文章通过解读V8源码,带你探索`Array.prototype.sort`函数下的算法实现. 来,先把你用过的和听说过的排序算法都列出来: * 快速排序 * 冒泡排序 * 插入排序 * 归并排序 * 堆排序 * 希尔排序 * 选择排序 * 计数排序 * 桶排序 * 基数排序 * ... 答题环节到了, sort 函数使用的以上哪一种算法? 如果你在网上搜索过关于 sort 源码的文章,可能会告诉你数组长度小于10用插入排序,否则用快速排序. 开始我也是">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">【深度】扒开V8引擎的源码，我找到了你们想要的前端算法（下次面试官再问算法，用它怼回去！）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>算法对于前端工程师来说总有一层神秘色彩，这篇文章通过解读V8源码，带你探索`Array.prototype.sort`函数下的算法实现。</p>
<p>来，先把你用过的和听说过的排序算法都列出来：</p>
<p>* 快速排序<br />
* 冒泡排序<br />
* 插入排序<br />
* 归并排序<br />
* 堆排序<br />
* 希尔排序<br />
* 选择排序<br />
* 计数排序<br />
* 桶排序<br />
* 基数排序<br />
* ...</p>
<p>答题环节到了， sort 函数使用的以上哪一种算法？</p>
<p>如果你在网上搜索过关于 sort 源码的文章，可能会告诉你数组长度小于10用插入排序，否则用快速排序。</p>
<p>开始我也是这么认为的，可当我带着答案去 GitHub 验证的时候发现并非如此。</p>
<p>首先我并没有找到对应的 js 源码（文章说实现逻辑是用js写的），因为但新版本的V8源码已经修改，改用`V8 Torque`。`V8 Torque`是专门用来开发V8而创造的语言，语法类似TypeScript（再一次证明TypeScript的价值），它的编译器使用`CodeStubAssembler`转换成高效的汇编代码。<br />
简单理解起来就是创造了一个类似TypeScript的高效的高级语言，这个语言的文件后缀是`tq`。</p>
<p>这里需要感谢 [justjavac](https://justjavac.com/about.html) 大神指点~</p>
<p>其次当我开始阅读源码的时候，并没有找到使用快速排序的代码，也没有找到判断数组长度的常数值10。</p>
<p>所有的证据表明，之前的源码解读文章很可能已经过时。</p>
<p>那么最新版本的 V8 用的是什么排序算法呢？</p>
<p># 算法解读</p>
<p>V8引擎在xx版本之后就舍弃了快速排序，因为它不是稳定的排序算法，在最坏情况下，时间复杂度会降级到O(n^2)。<br />
而是采用了一种混合排序的算法：TimSort。<br />
这种功能算法最初用于Python语言中，严格地说它t不属于以上10种排序算法中的任何一种，属于一种混合排序算法：<br />
在数据量小的子数组中使用**插入排序**，然后再使用**归并排序**将有序的子数组进行合并排序，时间复杂度为 O(nlogn) 。</p>
<p>结合V8源码，具体实现步骤如下：</p>
<p>1. 判断数组长度，小于2直接返回，不排序。<br />
2. 开始循环。<br />
3. 找出一个有序子数组，我们称之为“run”，长度为 currentRunLength 。<br />
4. 计算最小合并序列长度 minRunLength （这个值会根据数组长度动态变化，在32~64之间）。<br />
5. 比较 currentRunLength 和 minRunLength ，如果 currentRunLength &gt;= minRunLength ，否则采用插入排序补足数组长度至 minRunLength ，将 run 压入栈 pendingRuns 中。<br />
6. 每次有新的 run 被压入 pendingRuns 时保证栈内任意3个连续的 run（run0, run1, run2）从下至上满足run0&gt;run1+run2 &amp;&amp; run1&gt;run2 ，不满足的话进行调整直至满足。<br />
7. 如果剩余子数组为0，结束循环。<br />
8. 合并栈中所有 run，排序结束。</p>
<p># 源码解读</p>
<p>## 源码路径</p>
<p>`/thrid_party/v8/builtins/array-sort.tq`</p>
<p>## 调用栈</p>
<p>```<br />
1386 ArrayPrototypeSort<br />
1403 ArrayTimSort<br />
1369 ArrayTimSortImpl<br />
1260 ComputeMinRunLength // 计算 minRunLength<br />
// while循环<br />
1262 CountAndMakeRun // 计算当前 run 的长度<br />
1267 BinaryInsertionSort // 用插入排序补足 run 长度<br />
1274 MergeCollapse // 放入 pendingRuns 并根据需要进行调整<br />
// 循环结束<br />
1281 MergeForceCollapse // 合并 pendingRuns 中所有 run<br />
```</p>
<p>## 核心源码</p>
<p>tq语言虽然有些不一样，但如果有TypeScript基础的话阅读起来应该不成问题。<br />
下面重点解读3个函数的源码：</p>
<p>```<br />
// 在while循环之前调用，每次排序只调用一次，用来计算 minRunLength<br />
macro ComputeMinRunLength(nArg: Smi): Smi {<br />
  let n: Smi = nArg;<br />
  let r: Smi = 0;</p>
<p>assert(n &gt;= 0);<br />
  // 不断除以2，得到结果在 32~64 之间<br />
  while (n &gt;= 64) {<br />
    r = r | (n &amp; 1);<br />
    n = n &gt;&gt; 1;<br />
  }</p>
<p>const minRunLength: Smi = n + r;<br />
  assert(nArg (workArray.objects[low]);<br />
  const elementLowPred = UnsafeCast(workArray.objects[low - 1]);<br />
  // 调用比对函数来比对数据<br />
  let order = sortState.Compare(elementLow, elementLowPred);</p>
<p>const isDescending: bool = order (workArray.objects[idx]);<br />
    order = sortState.Compare(currentElement, previousElement);</p>
<p>if (isDescending) {<br />
      if (order &gt;= 0) break;<br />
    } else {<br />
      if (order run[n+1]+run[n+2] 且 run[n+1]&gt;run2[n+2]<br />
transitioning macro MergeCollapse(context: Context, sortState: SortState) {<br />
    const pendingRuns: FixedArray = sortState.pendingRuns;</p>
<p>while (GetPendingRunsSize(sortState) &gt; 1) {<br />
      let n: Smi = GetPendingRunsSize(sortState) - 2;</p>
<p>if (!RunInvariantEstablished(pendingRuns, n + 1) ||<br />
          !RunInvariantEstablished(pendingRuns, n)) {<br />
        if (GetPendingRunLength(pendingRuns, n - 1) 【深度】扒开V8引擎的源码，我找到了你们想要的前端算法（下次面试官再问算法，用它怼回去！）</p>
<p>原文地址：https://www.cnblogs.com/yalishizhude/p/11462621.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 12:01:32 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e9%80%89%e6%8b%a9/" title="选择">选择</a>, <a href="https://www.biecuoliao.com/tag/contex/" title="contex">contex</a>, <a href="https://www.biecuoliao.com/tag/%e6%8a%80%e6%9c%af/" title="技术">技术</a>, <a href="https://www.biecuoliao.com/tag/%e6%8e%92%e5%ba%8f/" title="排序">排序</a>, <a href="https://www.biecuoliao.com/tag/pos/" title="pos">pos</a>, <a href="https://www.biecuoliao.com/tag/%e9%80%bb%e8%be%91/" title="逻辑">逻辑</a>, <a href="https://www.biecuoliao.com/tag/%e7%bd%91%e4%b8%8a/" title="网上">网上</a>, <a href="https://www.biecuoliao.com/tag/%e9%ab%98%e7%ba%a7%e8%af%ad%e8%a8%80/" title="高级语言">高级语言</a>, <a href="https://www.biecuoliao.com/tag/compare/" title="compare">compare</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>【深度】扒开V8引擎的源码，我找到了你们想要的前端算法（下次面试官再问算法，用它怼回去！）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kgdQj0.html" rel="bookmark">关于阅读框架源码后的一些敢想</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				记得之前做毕业设计的时候看过status1的源码当时感觉挺简单的,不就是写几个xml配置文件然后在利用反射实例化成对象在执行相应的方法吗?当时以为自己好牛啊!以至于在学校做组合项目的时候自己自以为是的写了一个数据层的封装给组员使用,记得当时对外暴露的方法就是sql跟参数,庆幸的是组合项目完成后那个封装既然没出一点问题. 当自己现在再回过头去看status的源码的时候,感觉自己有些看不懂了.这两年也看了不少开源框架的源码像tomcat,heritrix,lucene,openfire,tigase			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Q0xyvB3.html" rel="bookmark">artTemplate模板引擎的源码拜读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最初接触的模板引擎还是基于node的ejs,当时觉得很神奇原来还可以这么玩,后来随着学习的深入,使用过jade,doT等,当然还有一些比较火的诸如juicer.underscore还没有深入接触,直到今年上半年由于项目需要就想着要不试试腾讯的artTemplate,感觉牛逼也吹的挺响的.开始了解后,觉得它比我之前使用过的jade.doT都好用,调试神马的也方便很多,采用预编译的方式也让性能非常优越. 其实看了源码后简单的总结出来就是这么一句话:就是先获取html中对应的id下得innerHTML			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/412RDJM.html" rel="bookmark">只需一句话就能搞定NVelocity模板引擎，源码&plus;解析&plus;文档&plus;资料&plus;注释</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				好长时间不发技术方面的动态了,今天无聊就发篇关于NVelocity的技术文章吧,这门技术来源于java开源项目Velocity,比较好用,其他的我也不过多介绍了,没听过的在文章末尾会有介绍,下面我们就实战吧~ 咱们直接上最简单的方法,一句话搞定: DNTNvelocityHelper.NvelocityTemplate(context.Request.MapPath(&quot;~/NVelocity/templates/&quot;), context, &quot;Templater_index.dn			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jee57M.html" rel="bookmark">java 在线编辑模版 代码编辑器 兼容手机平板PC freemaker 静态引擎 网站源码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java 企业网站源码 前后台都有 静态模版引擎, 代码生成器大大提高开发效率 前台: 支持三套模版, 可以在后台切换 系统介绍: 1.网站后台采用主流的 SSM 框架 jsp JSTL,网站后台采用freemaker静态化模版引擎生成html 2.因为是生成的html,所以访问速度快,轻便,对服务器负担小 3.网站前端采用主流的响应式布局,同一页面同时支持PC.平板.手机(三合一)浏览器访问 4.springmvc +spring4.2.5+ mybaits3.3  SSM 普通java we			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02mr1nM.html" rel="bookmark">Nodejs事件引擎libuv源码剖析之：高效线程池&lpar;threadpool&rpar;的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				声明:本文为原创博文,转载请注明出处. Nodejs编程是全异步的,这就意味着我们不必每次都阻塞等待该次操作的结果,而事件完成(就绪)时会主动回调通知我们.在网络编程中,一般都是基于Reactor线程模型的变种,无论其怎么演化,其核心组件都包含了Reactor实例(提供事件注册.注销.通知功能).多路复用器(由操作系统提供,比如kqueue.select.epoll等).事件处理器(负责事件的处理)以及事件源(linux中这就是描述符)这四个组件.一般,会单独启动一个线程运行Reactor实例来			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aRwbq3.html" rel="bookmark">Mahout推荐系统引擎RecommenderEvaluator源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在http://blog.csdn.net/jianjian1992/article/details/47304337里边有关于推荐系统的完整代码,其中有一个评价器RecommenderEvaluator用来评价推荐器的好坏. RecommenderEvaluator evalutor = new AverageAbsoluteDifferenceRecommenderEvaluator(); System.out.println(&quot;eval:&quot;+ evalutor.evaluate(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPw7vv4.html" rel="bookmark">图像处理之增强---图像增强算法四种，图示与源码，包括retinex（ssr、msr、msrcr）和一种混合算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				申明:本文非笔者原创,原文转载自:http://blog.csdn.net/onezeros/article/details/6342661 两组图像:左边较暗,右边较亮 第一行是原图像,他们下面是用四种算法处理的结果 依次为: 1.一种混合算法 2.msr,multi-scale retinex 3.msrcr,multi-scale retinex with color restoration 4.ssr,single scale retinex           源码,retinex算法			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kjj9EM.html" rel="bookmark">B&sol;S MVC工作流引擎 OA 源码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本源码是一款集成工作流引擎的ASP.NET MVC快速开发平台,由从事六年以上OA及工作流开发与实施的团队设计开发,该工作流平台已应用于众多大型企事业单位.拥有全浏览器兼容的可视化流程设计器.表单设计器.基于角色的权限管理等先进设计理念,是您开发OA.CRM.HR等企事业各种应用管理系统的最佳基础平台. Razor视图引擎 功能介绍1.流程测试:请假申请.物资采购申请.自定义表单.新闻发布.2.流程处理:待办事项.已办事项.签名管理.意见管理.工作委托.3.流程管理:流程设计.表单设计.按钮管理			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O6QKr0.html" rel="bookmark">【原创】使用JS封装的一个小型游戏引擎及源码分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 /** 2 * @description: 引擎的设计与实现 3 * @user: xiugang 4 * @time: 2018/10/01 5 */ 6 7 /* 8 * V1.0: 引擎实现的基本模块思路 9 * 1.创建一个游戏引擎对象及精灵对象 10 * 2.将精灵对象添加到引擎中去,并实现播放动画效果以及需要用到的回调方法 11 * 3.启动引擎 12 * */ 13 14 /* 15 * V2.0: 实现游戏循环模块 16 * 1.如果游戏暂停了,就跳过以下各步骤,并在100毫			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V02qxaM.html" rel="bookmark" class="title">BZOJ1818&colon; &lbrack;Cqoi2010&rsqb;内部白点</a>
					<div>
						1818: [Cqoi2010]内部白点 Time Limit: 10 Sec  Memory Limit: 64 MBSubmit: 1004  Solved: 485[Submit][Status ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMz2zdM.html" rel="bookmark" class="title">基于汉字字频特征实现99&period;99&percnt;准确率的新闻文本分类器（四）</a>
					<div>
						基于汉字字频特征实现99.99%准确率的新闻文本分类器(一) 基于汉字字频特征实现99.99%准确率的新闻文本分类器(二) 基于汉字字频特征实现99.99%准确率的新闻文本分类器(三) 基于汉字字频特 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dAzVZ3.html" rel="bookmark" class="title">文件特殊权限及facl</a>
					<div>
						特殊权限 SUID,SGID,STICKY 权限匹配模型: 判断进程的 发起者 是否为被访问文件的 属主,如果是 则应用属主的权限: 判断进程的 发起者 是否为陪访问文件的 属组,如果是 则应用属组的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RGN5q3.html" rel="bookmark" class="title">网站浮动窗口 备忘</a>
					<div>
						&lt;div id=&quot;roll&quot; style=&quot;z-index: 200000;text-align:right;&quot;&gt; &lt;a href=&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y7L1r4.html" rel="bookmark" class="title">Error prompt&colon;&OpenCurlyDoubleQuote;wget&colon; unable to resolve host address&rdquo;---Solution</a>
					<div>
						//Situation System prompts that:&quot;wget: unable to resolve host address&quot;. //Analysis Unable  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0le5wP3.html" rel="bookmark" class="title">抠图 &amp;nbsp&semi;   色彩搭配 &amp;&num;160&semi; &amp;nbsp&semi;</a>
					<div>
						色彩搭配: 1.为什么要进行色彩搭配? 动物:1吸引异性   2保护自己  人类:突出个性时尚,吸引眼球,增加回头率 2.如何配色? 撞色   红----绿 黑----白 青----紫 在设计时最好不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JydxB3.html" rel="bookmark" class="title">OpenQuery usage</a>
					<div>
						Executes the specified pass-through query on the specified linked server. This server is an OLE DB d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qE2ap3.html" rel="bookmark" class="title">Qt之控件颜色面板类QPalette（转自CSDN，xgbing&rpar;</a>
					<div>
						QPalette类提供了绘制QWidget控件时使用的颜色. 控件的颜色状态分三种: (1)Active,激活状态 (2)Disabled,禁用状态 (3)Inactive,未激活状态 控件在这三种不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Moajvy3.html" rel="bookmark" class="title">excel 学习</a>
					<div>
						最近越來越感覺到熟練運用office軟件是一門很深的學問,以前一直忽視了這個技能,因爲從來都不覺得這個有什麼技術難度.正是因爲這樣想,所以才一直沒能去好好研究使用這套工具.現在卻覺得有必要學習,在於: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nLkBN4.html" rel="bookmark" class="title">ftp读取txt数据并插入数据库</a>
					<div>
						去官网下载http://enterprisedt.com/ .netftp组件 目前最新版本为2.2.3,下载后在bin目录中找到edtFTPnet.dll,在项目中添加引用. using Enter ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzEYwy4.html" rel="bookmark" class="title">python检测linux进程是否运行</a>
					<div>
						python检测linux下运行的进程 # -*- coding:utf8 -*- import subprocess import sys status_ok = 0 status_critical ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38p7PW3.html" rel="bookmark" class="title">Python基础教程总结（二）</a>
					<div>
						上周总结了一下Python的一些基本数据类型和用法.这次总结一下4-9章的内容,完后,赶紧学以致用吧. 5. 第四章——字典:当索引不好用时 字典是Python中唯一内建的映射类型.字典中的值并没有特 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWq1dr3.html" rel="bookmark" class="title">排序----demo----</a>
					<div>
						排序1---冒泡法: 单向冒泡排序的基本原理就是:对于给定的n个数据,从第一个数据开始一次对相邻的两个数据进行比较,当前面的数据大于后面的数据时,交换位置,进行一轮比较和换位后,n个数据中最大的那个被 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kNpjzM.html" rel="bookmark" class="title">数组连续最大子和及环形数组最大子和</a>
					<div>
						问题1: /*求连续子数组的最大和: * 设curSum为当前子数组(ai, ai+1, ......, aj)的和 * sum存放到目前为止子数组和的最大值 * 1. cursum+ai&gt;0; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K8pPL3.html" rel="bookmark" class="title">2，简单交互对话框</a>
					<div>
						-----后台 using System; using System.Collections.Generic; using System.Linq; using System.Web; using S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xejZr3.html" rel="bookmark" class="title">meta标签的使用方法（PC端）</a>
					<div>
						&lt;!DOCTYPE html&gt; &lt;html lang=&quot;en&quot;&gt; &lt;head&gt; &lt;!--设定页面使用的字符集--&gt; &lt;meta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k6nDLM.html" rel="bookmark" class="title">iBatis框架之配置文件之注意点之总结</a>
					<div>
						1.配置文件sqlMap.xml中需要注意的点 比如: &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot; ?&gt; &lt;!D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n7LRP3.html" rel="bookmark" class="title">Apache &plus; SSL搭建Linux证书服务器</a>
					<div>
						HTTPS是一个安全的访问方式,数据在传输过程中是加密的,HTTPS基于SSL加密. 一:安装apache模块和ssl模块. yum install httpd httpd-devel mod_ssl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41eVgv4.html" rel="bookmark" class="title">java进行ip号码段正则匹配</a>
					<div>
						java正则匹配IP号码段 public static boolean IPMatch(List ips, String ip) { if (ips.contains(ip)) { return tr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e8AxvM.html" rel="bookmark" class="title">uva1400线段树</a>
					<div>
						题意:在l,r区间找到 最靠近左边的和最大区间. 要理清思路写.简单区间合并.查找要麻烦点,三个查找函数,分别是向左范围内最大连续,向右范围内最大连续,整体最大连续. #include &lt;cst ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
